/*** TCP Client ***/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define	SERVICE_NAME	"tcpinetd"
#define	PROTOCOL	"tcp"
char*           host_name;

int	Connect()
{
int	SocketNumber;		/* Socket descripter */
struct	servent	*ServiceEntry;	/* service entry */
struct	hostent	*HostEntry;	/* host entry */
struct	sockaddr_in	sin;	/* Socket Entry */

/* Get Service Entry by Service-Name */

if((struct servent *)NULL == (ServiceEntry =
	getservbyname(SERVICE_NAME,PROTOCOL)))
	{
	printf("\7No service [%s].\n",SERVICE_NAME);
	exit(1);
	}

/* Get Host Entry by Host-Name */

if((struct hostent *)NULL == (HostEntry = gethostbyname(host_name)))
	{
	printf("\7No Hosts [%s].\n",host_name);
	exit(1);
	}

/* Get Socket */

if(0 > (SocketNumber = (socket(AF_INET,SOCK_STREAM,0))))
	{
	printf("\7Cannot get Socket.\n");
	exit(1);
	}

/* Set protocol family name */
sin.sin_family = AF_INET;

/* Set Host Address */
bcopy(HostEntry->h_addr,&sin.sin_addr,HostEntry->h_length);

/* Set Port N.o. */
sin.sin_port = ServiceEntry->s_port;

if(0 > connect(SocketNumber,(struct sockaddr *)(&sin),sizeof(sin)))
	{
	printf("\7Cannot Connect.\n");
	exit(1);
	}

return SocketNumber;
}

void	Disconnect(int SocketNumber)
{
close(SocketNumber);
}

void	SendData(int SocketNumber,char *line)
{
if(strlen(line) != write(SocketNumber,line,strlen(line)))
	{
	printf("\7Send Failed.\n");
	exit(1);
	}
}

int	RecvData(int SocketNumber,char *line)
{
int	i;

for(i = 0 ;;)
	{
	if(1 != read(SocketNumber,line + i,1))
		continue;
	else
		{
		i++;
		*(line + i) = (char)0;
	
		if(((char)('\n')) == *(line + i - 1))
			return i;
		}
	}
}

int	main(int ac, char *av[])
{
int	Sock;
char	Key[256];
char	Data[256];
char	buff[256];

if(ac != 2)
   fprintf(stderr,"Usage:%s [hostname]\n",av[0]); 

host_name = av[1];

Sock = Connect();	/* Connect */
printf("Connected.\n");

for(;;)
	{
	char	*p;

	printf("Input Keyword = ");
	fflush(stdout);

	//gets(Key);
	fgets(Key,256,stdin);
	Key[strlen(Key)-1] = '\0';
	sprintf(buff,"%s=\n",Key);
	SendData(Sock,buff);		/* Send It ! */

	if(0 == strlen(Key))
		break;			/* If End Mark */

	/* ---- Waiting for Server response Here --- */

	(void)RecvData(Sock,buff);		/* Recv It ! */

	if((char *)NULL != (p = strchr(buff,'\n')))
		*p = (char)0;

	if((char *)NULL != (p = strchr(buff,'=')))
		p++;

	printf("Keyword = [%s] / Data = [%s]\n\n",Key,p);
	}

Disconnect(Sock);	/* Disconnect */
printf("Disocnnected.\n");
 exit (0);
}
